<?php


// include compatibility plugin
//
if (defined('SM_PATH'))
   include_once(SM_PATH . 'plugins/compatibility/functions.php');
else if (file_exists('../plugins/compatibility/functions.php'))
   include_once('../plugins/compatibility/functions.php');
else if (file_exists('./plugins/compatibility/functions.php'))
   include_once('./plugins/compatibility/functions.php');



function change_mysqlpass_check_password_force_do() {
    
   global $plugin_change_mysqlpass;
        
                
   // get global variables for versions of PHP < 4.1
   //   
   if (!compatibility_check_php_version(4, 1)) {
      global $HTTP_POST_VARS, $HTTP_SERVER_VARS;
      $_POST = $HTTP_POST_VARS;
      $_SERVER = $HTTP_SERVER_VARS;
   }
        
                
   // get flag that tells us if this is a password submission attempt...
   //   
   if (isset($_POST['plugin_change_mysqlpass']))
      $plugin_change_mysqlpass = $_POST['plugin_change_mysqlpass'];

        
   if (!isset($plugin_change_mysqlpass))
      return;     

        
   // go check password
   //
   if (compatibility_check_SM_version(1, 3))
      include_once(SM_PATH . 'plugins/change_mysqlpass/options.php');
   else
      include_once('../plugins/change_mysqlpass/options.php');

        
   // if we come back after no success, redirect to right main
   //   
   $location = $_SERVER['PHP_SELF'];
   $location = str_replace('webmail', 'right_main', $location); 
   header('Location: ' . $location);
   exit(0);
                
                
}                       
        


function change_mysqlpass_password_force_do() {

    global $plugin_change_mysqlpass;
    global $mysql_server, $mysql_database, $mysql_table, $mysql_userid_field,
           $mysql_password_field, $mysql_manager_id, $mysql_manager_pw,
           $mysql_saslcrypt, $mysql_unixcrypt, $mysql_MD5crypt,
           $use_ssl_for_password_change, $mysql_password_force,
           $mysql_password_change_field, $mysql_password_change_field_delimiter,
           $mysql_password_change_yes_value, $mysql_password_change_no_value,
           $split_username_query, $split_username_expression,
           $split_username_domain_field, $debug;


    // get global variables for versions of PHP < 4.1
    //
    if (!compatibility_check_php_version(4, 1)) {
       global $HTTP_SESSION_VARS, $HTTP_GET_VARS;
       $_SESSION = $HTTP_SESSION_VARS;
       $_GET = $HTTP_GET_VARS;
    }

    if (compatibility_check_SM_version(1, 3))
       include_once(SM_PATH . 'plugins/change_mysqlpass/config.php');
    else
       include_once('../plugins/change_mysqlpass/config.php');
    $Messages = array();


    // if we already have messages, just fill them into the array
    // and go to the password entry page again
    //
    if (isset($_GET['messages']))
    {

       $Messages = explode('||', urldecode($_GET['messages']));
       if (compatibility_check_SM_version(1, 3))
          include_once(SM_PATH . 'plugins/change_mysqlpass/options.php');
       else
          include_once('../plugins/change_mysqlpass/options.php');

    }


    else if ($mysql_password_force) {

        if ($debug)
                array_push($Messages, 'Connecting to Database');

        $ds=mysql_connect($mysql_server, $mysql_manager_id, $mysql_manager_pw);
        if (! $ds) {
                array_push($Messages,'Can\'t connect to Database Server, please try later!');
                return $Messages;
        }

        if (!mysql_select_db($mysql_database,$ds)) {
                array_push($Messages,'Database not found on server');
                return $Messages;
        }

        $username = $_SESSION['username'];

        $query_string = 'SELECT ' . $mysql_password_change_field
                  . ' FROM '  . $mysql_table
                  . ' WHERE ' . $mysql_userid_field . '="' . $username . '"';
	print( $query_string );
        if ($debug)
                array_push($Messages,$query_string);

        $select_result = mysql_query($query_string, $ds);

        $reminderfield = mysql_result($select_result, 0, $mysql_password_change_field);

        @mysql_close($ds);

        if ($reminderfield == $mysql_password_change_yes_value) {
                array_push($Messages, 'Periodically, we ask that you change your password.  This is done to help maintain good security for your email account.');
                if (compatibility_check_SM_version(1, 3))
                   include_once(SM_PATH . 'plugins/change_mysqlpass/options.php');
                else
                   include_once('../plugins/change_mysqlpass/options.php');
                if (!isset($plugin_change_mysqlpass))
                        exit;
        } else {
                return;
        }
   }

   return;
}


function change_mysqlpass_opt_do() {
    global $optpage_blocks;
        
    $optpage_blocks[] = array(
        'name' => _("Change Password"),
        'url' => '../plugins/change_mysqlpass/options.php',
        'desc' => _("Use this to change your email password."),
        'js' => FALSE
    );          
                
}       

        
// OK, so this is not what this is supposed to be
// used for(?), but I couldn't figure it out any
// other way -- the save_pref method below is not
// working anymore, especially after turning off
// register_globals
//      
function change_mysqlpass_optpage_loadinfo_do() {

   global $optpage_name, $plugin_change_mysqlpass;

        
   // get global variables for versions of PHP < 4.1
   //   
   if (!compatibility_check_php_version(4, 1)) {
      global $HTTP_GET_VARS, $HTTP_POST_VARS;
      $_GET = $HTTP_GET_VARS;
      $_POST = $HTTP_POST_VARS;
   }            
                
                        
   if (isset($_POST['plugin_change_mysqlpass']))
      $plugin_change_mysqlpass = $_POST['plugin_change_mysqlpass'];
   if (isset($_GET['plugin_change_mysqlpass']))
      $plugin_change_mysqlpass = $_GET['plugin_change_mysqlpass'];

   
   if (isset($plugin_change_mysqlpass))
      if ($plugin_change_mysqlpass)
         $optpage_name = _("Password changed successfully.<br>Please use your new password to log in from now on.");
      else
         $optpage_name = _("Password change cancelled.<br>Your password has NOT been changed.");
        
}       
        
        

// this is old school and doesn't work any more, especially
// with register_globals = Off...
//
function change_mysqlpass_save_pref_do() {


   global $plugin_change_mysqlpass, $optmode;


   // get global variables for versions of PHP < 4.1
   //
   if (!compatibility_check_php_version(4, 1)) {
      global $HTTP_GET_VARS, $HTTP_POST_VARS;
      $_GET = $HTTP_GET_VARS;
      $_POST = $HTTP_POST_VARS;
   }
   
   
   // get flag that tells us if this is a password submission attempt...
   // 
   if (isset($_GET['plugin_change_mysqlpass']))
      $plugin_change_mysqlpass = $_GET['plugin_change_mysqlpass'];
   if (isset($_POST['plugin_change_mysqlpass']))
      $plugin_change_mysqlpass = $_POST['plugin_change_mysqlpass'];

   

   if (!isset($plugin_change_mysqlpass))
      return;

   $optmode = 'display';

   if (!$plugin_change_mysqlpass)
      echo '<p align=center><b>' . _("Password change cancelled.") . '&nbsp;&nbsp;' . _("Your password has NOT been changed.") . '</b></p>';

   else
      echo '<p align=center><b>' . _("Password changed successfully.") . '&nbsp;&nbsp;' . _("Please use your new password to log in from now on.") . '</b></p>';

}



?>
