<?php

        // Global Variables, don't touch these unless you want to break the plugin
        //
        global $mysql_server, $mysql_database, $mysql_table, $mysql_userid_field,
               $mysql_password_field, $mysql_manager_id, $mysql_manager_pw,
               $mysql_saslcrypt, $mysql_unixcrypt, $mysql_MD5crypt,
               $use_ssl_for_password_change, $mysql_password_force,
               $mysql_password_change_field, $mysql_password_change_field_delimiter,
               $mysql_password_change_yes_value, $mysql_password_change_no_value,
               $split_username_query, $split_username_expression,
               $split_username_domain_field, $debug, $update_clear_passwd_field;

// CLWELLS - 03/22/06 - MAKING CLUSTER NICE
ini_set('include_path', '/home/interworx/lib/pear' . ':'. ini_get('include_path') );
require_once( 'DB.php' );
$iworx_ini = parse_ini_file( '/home/interworx/lib/squirrelmail/iworx.ini', true );
$dsn = DB::parseDSN( $iworx_ini['vpopmail']['dsn'] );

// setup the socket connect
if( isset( $dsn['socket'] ) && $dsn['socket'] !== false ) {
  $mysql_server = ":{$dsn['socket']}";
} else {
  // setup the tcp connect
  $mysql_server = "{$dsn['hostspec']}:{$dsn['port']}";
}

// set the rest
$mysql_database = $dsn['database'];
$mysql_table    = 'vpopmail';

// The names of the user ID and password columns
$mysql_userid_field = 'pw_name';
$mysql_password_field ='pw_passwd';

// The user to log into MySQL with (must have rights)
$mysql_manager_id = $dsn['username'];
$mysql_manager_pw = $dsn['password'];
// CLWELLS - END


        //---------------------------------------------------------
        // Password encryption (or lack thereof)
        //---------------------------------------------------------

	// Set only one of the options below to 1.

	// Set to 1 if the password column is encrypted
	// using the MySQL password() function.
	$mysql_saslcrypt = 0;

	// Set to 1 if the password column is encrypted
	// using the UNIX crypt() function.
	$mysql_unixcrypt = 0;

	// Set to 1 if the password column is to use MD5 encryption
	$mysql_MD5crypt = 1;

	// Set both to 0 if the password is stored in the
	// column in plaintext.



        //---------------------------------------------------------
        // SSL encryption during password change
        //---------------------------------------------------------
        // Set to 1 to enforce SSL connections when
        // changing passwords.  NOTE - This should be
        // turned OFF if you serve your entire webmail
        // in https!
        $use_ssl_for_password_change = 0;



        //---------------------------------------------------------
        // Force password change mode
        //---------------------------------------------------------
	// Enable functionality to force users to change
        // their passwords
	$mysql_password_force = 0;

	// Force password change field
	$mysql_password_change_field = 'passwd_expire';

        // Set this as a double quote if the above-defined
        // field is a character data field, otherwise,
        // set it to an empty string
        $mysql_password_change_field_delimiter = '"';
        //$mysql_password_change_field_delimiter = '';

        // Force password YES and NO values
        // the value the above-defined field will be set to
        // to indicate that the user must change passwords
        // upon next login (and not)
        //
        $mysql_password_change_yes_value = 'Y';
        $mysql_password_change_no_value = 'N';
        //$mysql_password_change_yes_value = 1;
        //$mysql_password_change_no_value = 0;



        //---------------------------------------------------------
        // Multiple database field setup
        //---------------------------------------------------------
        // The following settings ONLY apply if your IMAP
        // login is comprised of a join between two separate
        // database columns
        //
        // Set this to 1 to turn such functionality on
        //
        $split_username_query = 1;

        // This is typically the @ sign, although it can be any
        // regular expression which should be used to split the
        // full user name into two separate pieces (for example,
        // using @, "jose@myowndomain.com" becomes "jose" and
        // "myowndomain.com")
        //
        $split_username_expression = '@';

        // This is the name of the second database column to query
        //
        $split_username_domain_field = 'pw_domain';



        //---------------------------------------------------------
        // Multiple password fields
        //---------------------------------------------------------
        // The following settings ONLY apply if you keep
        // a cleartext copy of users' passwords along with
        // an encrypted one (CAREFUL!).  Set this variable
        // to the name of the cleartext password field
        // and it will be updated IN ADDITION to the encrypted
        // field indicated above.  Others should leave this
        // setting as an empty string.
        //
        $update_clear_passwd_field = '';



        //---------------------------------------------------------
        // Debug mode
        //---------------------------------------------------------
        // Debug
        $debug = 0;

?>
